diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 1f744bec9..b1373963b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1682,205 +1538,177 @@ public class World implements MutableWorldSource {
         entity.zo = entity.z;
         entity.yRotO = entity.yRot;
         entity.xRotO = entity.xRot;
-        if(flag && entity.addedToChunk)
-        {
-            if(entity.vehicle != null)
-            {
+        if (flag && entity.addedToChunk) {
+            if (entity.vehicle != null) {
                 entity.rideTick();
-            } else
-            {
+            } else {
                 entity.tick();
             }
         }
-        if(Double.isNaN(entity.x) || Double.isInfinite(entity.x))
-        {
+        if (Double.isNaN(entity.x) || Double.isInfinite(entity.x)) {
             entity.x = entity.xo;
         }
-        if(Double.isNaN(entity.y) || Double.isInfinite(entity.y))
-        {
+        if (Double.isNaN(entity.y) || Double.isInfinite(entity.y)) {
             entity.y = entity.yo;
         }
-        if(Double.isNaN(entity.z) || Double.isInfinite(entity.z))
-        {
+        if (Double.isNaN(entity.z) || Double.isInfinite(entity.z)) {
             entity.z = entity.zo;
         }
-        if(Double.isNaN(entity.xRot) || Double.isInfinite(entity.xRot))
-        {
+        if (Double.isNaN(entity.xRot) || Double.isInfinite(entity.xRot)) {
             entity.xRot = entity.xRotO;
         }
-        if(Double.isNaN(entity.yRot) || Double.isInfinite(entity.yRot))
-        {
+        if (Double.isNaN(entity.yRot) || Double.isInfinite(entity.yRot)) {
             entity.yRot = entity.yRotO;
         }
         int k = MathHelper.floor(entity.x / Chunk.CHUNK_SIZE_X);
         int l = MathHelper.floor(entity.y / 16D);
         int i1 = MathHelper.floor(entity.z / Chunk.CHUNK_SIZE_Z);
-        if(!entity.addedToChunk || entity.chunkCoordX != k || entity.chunkCoordY != l || entity.chunkCoordZ != i1)
-        {
-            if(entity.addedToChunk && isChunkLoaded(entity.chunkCoordX, entity.chunkCoordZ))
-            {
+        if (!entity.addedToChunk || entity.chunkCoordX != k || entity.chunkCoordY != l || entity.chunkCoordZ != i1) {
+            if (entity.addedToChunk && isChunkLoaded(entity.chunkCoordX, entity.chunkCoordZ)) {
                 getChunkFromChunkCoords(entity.chunkCoordX, entity.chunkCoordZ).removeEntityAtIndex(entity, entity.chunkCoordY);
             }
-            if(isChunkLoaded(k, i1))
-            {
+            if (isChunkLoaded(k, i1)) {
                 entity.addedToChunk = true;
                 getChunkFromChunkCoords(k, i1).addEntity(entity);
-            } else
-            {
+            } else {
                 entity.addedToChunk = false;
             }
         }
-        if(flag && entity.addedToChunk && entity.passenger != null)
-        {
-            if(entity.passenger.removed || entity.passenger.vehicle != entity)
-            {
+        if (flag && entity.addedToChunk && entity.passenger != null) {
+            if (entity.passenger.removed || entity.passenger.vehicle != entity) {
                 entity.passenger.vehicle = null;
                 entity.passenger = null;
-            } else
-            {
+            } else {
                 updateEntity(entity.passenger);
             }
         }
     }
 
-    public boolean checkIfAABBIsClear(AABB axisalignedbb)
-    {
-        if (axisalignedbb == null) return true;
-        List<Entity> list = getEntitiesWithinAABBExcludingEntity(null, axisalignedbb);
-        for(int i = 0; i < list.size(); i++)
-        {
+    public boolean checkIfAABBIsClear(@NotNull AABBdc aabb) {
+        List<Entity> list = getEntitiesWithinAABBExcludingEntity(null, aabb);
+        for (int i = 0; i < list.size(); i++) {
             Entity entity = list.get(i);
             if (entity instanceof MobFireflyCluster) continue;
-            if(!entity.removed && entity.blocksBuilding)
-            {
+            if (!entity.removed && entity.blocksBuilding) {
                 return false;
             }
         }
 
         return true;
     }
-    
-	public boolean getIsAnySolidGround(AABB boundingBox) {
-		int minX = MathHelper.floor(boundingBox.minX);
-		int maxX = MathHelper.floor(boundingBox.maxX);
-		int minY = MathHelper.floor(boundingBox.minY);
-		int maxY = MathHelper.floor(boundingBox.maxY);
-		int minZ = MathHelper.floor(boundingBox.minZ);
-		int maxZ = MathHelper.floor(boundingBox.maxZ);
-		
-		for(int x = minX; x <= maxX; x++) {
-			for(int y = minY; y <= maxY; y++) {
-				for(int z = minZ; z <= maxZ; z++) {
+
+    public boolean getIsAnySolidGround(@NotNull AABBdc aabb) {
+        int minX = MathHelper.floor(aabb.minX());
+        int maxX = MathHelper.floor(aabb.maxX());
+        int minY = MathHelper.floor(aabb.minY());
+        int maxY = MathHelper.floor(aabb.maxY());
+        int minZ = MathHelper.floor(aabb.minZ());
+        int maxZ = MathHelper.floor(aabb.maxZ());
+
+        for (int x = minX; x <= maxX; x++) {
+            for (int y = minY; y <= maxY; y++) {
+                for (int z = minZ; z <= maxZ; z++) {
                     Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-					if(block != null) {
-						return true;
-					}
-				}
-			}
-		}
-		
-		List<Entity> entities = getEntitiesWithinAABBExcludingEntity(null, boundingBox);
+                    if (block != null) {
+                        return true;
+                    }
+                }
+            }
+        }
+
+        List<Entity> entities = getEntitiesWithinAABBExcludingEntity(null, aabb);
 
         for (Entity entity : entities) {
-            AABB aabb = entity.getBb();
-            if (aabb != null && aabb.intersects(boundingBox)) {
-                collidingBoundingBoxes.add(aabb);
+            AABBdc collisionAABB = entity.getCollisionAABB();
+            if (collisionAABB != null && collisionAABB.intersectsAABB((AABBd) aabb)) {
+                this.collidingBoundingBoxes.add(collisionAABB);
             }
         }
-		
-		return false;
-	}
+
+        return false;
+    }
 
 
-	public boolean getIsAnyLiquid(AABB boundingBox) {
-		int minX = MathHelper.floor(boundingBox.minX);
-		int maxX = MathHelper.floor(boundingBox.maxX);
-		int minY = MathHelper.floor(boundingBox.minY);
-		int maxY = MathHelper.floor(boundingBox.maxY);
-		int minZ = MathHelper.floor(boundingBox.minZ);
-		int maxZ = MathHelper.floor(boundingBox.maxZ);
+    public boolean getIsAnyLiquid(@NotNull AABBdc aabb) {
+        int minX = MathHelper.floor(aabb.minX());
+        int maxX = MathHelper.floor(aabb.maxX());
+        int minY = MathHelper.floor(aabb.minY());
+        int maxY = MathHelper.floor(aabb.maxY());
+        int minZ = MathHelper.floor(aabb.minZ());
+        int maxZ = MathHelper.floor(aabb.maxZ());
 
-		for(int x = minX; x <= maxX; x++) {
-			for(int y = minY; y <= maxY; y++) {
-				for(int z = minZ; z <= maxZ; z++) {
-                    Block<?> block = Blocks.blocksList[getBlockId(x, y, z)];
-					if(block != null && block.getMaterial().isLiquid()) {
-						return true;
-					}
-				}
-			}
-		}
-
-		return false;
-	}
-
-    public boolean isBoundingBoxBurning(AABB aabb)
-    {
-        return isMaterialInBB(aabb, Material.fire, Material.lava);
-    }
-
-    public boolean handleMaterialAcceleration(AABB aabb, Material material, Entity entity, boolean addVelocity)
-    {
-        int i = MathHelper.floor(aabb.minX);
-        int j = MathHelper.floor(aabb.maxX + 1.0D);
-        int k = MathHelper.floor(aabb.minY);
-        int l = MathHelper.floor(aabb.maxY + 1.0D);
-        int i1 = MathHelper.floor(aabb.minZ);
-        int j1 = MathHelper.floor(aabb.maxZ + 1.0D);
-        if(!areBlocksLoaded(i, k, i1, j, l, j1))
-        {
+        TilePos tilePos = new TilePos(0, 0, 0);
+        for (tilePos.x = minX; tilePos.x <= maxX; tilePos.x++) {
+            for (tilePos.y = minY; tilePos.y <= maxY; tilePos.y++) {
+                for (tilePos.z = minZ; tilePos.z <= maxZ; tilePos.z++) {
+                    Block<?> block = getBlock(tilePos);
+                    if (block != null && block.getMaterial().isLiquid()) {
+                        return true;
+                    }
+                }
+            }
+        }
+
+        return false;
+    }
+
+    public boolean isBoundingBoxBurning(@NotNull AABBdc aabb) {
+        return isMaterialInBB(aabb, Materials.FIRE, Materials.LAVA);
+    }
+
+    public boolean handleMaterialAcceleration(@NotNull AABBdc aabb, @NotNull Material material, @NotNull Entity entity, boolean addVelocity) {
+        int minX = MathHelper.floor(aabb.minX());
+        int maxX = MathHelper.floor(aabb.maxX() + 1.0D);
+        int minY = MathHelper.floor(aabb.minY());
+        int maxY = MathHelper.floor(aabb.maxY() + 1.0D);
+        int minZ = MathHelper.floor(aabb.minZ());
+        int maxZ = MathHelper.floor(aabb.maxZ() + 1.0D);
+        if (!areBlocksLoaded(minX, minY, minZ, maxX, maxY, maxZ)) {
             return false;
         }
         boolean flag = false;
-        Vec3 vec3 = Vec3.fromPool(0.0D, 0.0D, 0.0D);
-        for(int k1 = i; k1 < j; k1++)
-        {
-            for(int l1 = k; l1 < l; l1++)
-            {
-                for(int i2 = i1; i2 < j1; i2++)
-                {
-                    Block<?> block = Blocks.blocksList[getBlockId(k1, l1, i2)];
-                    if(block == null || !isMaterialInBB(aabb, material))
-                    {
+        TilePos tilePos = new TilePos(0, 0, 0);
+        Vector3d velDir = new Vector3d();
+        for (tilePos.x = minX; tilePos.x < maxX; tilePos.x++) {
+            for (tilePos.y = minY; tilePos.y < maxY; tilePos.y++) {
+                for (tilePos.z = minZ; tilePos.z < maxZ; tilePos.z++) {
+                    Block<?> block = getBlock(tilePos);
+                    if (block == null || !isMaterialInBB(aabb, material)) {
                         continue;
                     }
                     flag = true;
-                    block.handleEntityInside(this, k1, l1, i2, entity, vec3);
+                    block.onEntityInside(this, tilePos, entity, velDir);
                 }
 
             }
 
         }
 
-        if(vec3.length() > 0.0D && addVelocity)
-        {
-            vec3 = vec3.normalize();
+        if (velDir.length() > 0.0D && addVelocity) {
+            velDir.normalize();
             double d = 0.014D;
-            entity.xd += vec3.x * d;
-            entity.yd += vec3.y * d;
-            entity.zd += vec3.z * d;
+            entity.xd += velDir.x * d;
+            entity.yd += velDir.y * d;
+            entity.zd += velDir.z * d;
         }
         return flag;
     }
 
-    public boolean isMaterialInBB(AABB aabb, Material ... materials)
-    {
-        int minX_i = MathHelper.floor(aabb.minX);
-        int maxX_i = MathHelper.floor(aabb.maxX + 1.0D);
-        int minY_i = MathHelper.floor(aabb.minY);
-        int maxY_i = MathHelper.floor(aabb.maxY + 1.0D);
-        int minZ_i = MathHelper.floor(aabb.minZ);
-        int maxZ_i = MathHelper.floor(aabb.maxZ + 1.0D);
-        for(int _x = minX_i; _x < maxX_i; _x++)
-        {
-            for(int _y = minY_i; _y < maxY_i; _y++)
-            {
-                for(int _z = minZ_i; _z < maxZ_i; _z++)
-                {
-                    Block<?> block = Blocks.blocksList[getBlockId(_x, _y, _z)];
-                    if(block != null) {
+    public boolean isMaterialInBB(@NotNull AABBdc aabb, @NotNull Material @NotNull ... materials) {
+        int minX_i = MathHelper.floor(aabb.minX());
+        int maxX_i = MathHelper.floor(aabb.maxX() + 1.0D);
+        int minY_i = MathHelper.floor(aabb.minY());
+        int maxY_i = MathHelper.floor(aabb.maxY() + 1.0D);
+        int minZ_i = MathHelper.floor(aabb.minZ());
+        int maxZ_i = MathHelper.floor(aabb.maxZ() + 1.0D);
+        TilePos tilePos = new TilePos(0, 0, 0);
+        for (tilePos.x = minX_i; tilePos.x < maxX_i; tilePos.x++) {
+            for (tilePos.y = minY_i; tilePos.y < maxY_i; tilePos.y++) {
+                for (tilePos.z = minZ_i; tilePos.z < maxZ_i; tilePos.z++) {
+                    Block<?> block = getBlock(tilePos);
+                    if (block != null) {
                         boolean isMaterial = false;
-                        for (Material m : materials){
+                        for (Material m : materials) {
                             if (block.getMaterial() == m) {
                                 isMaterial = true;
                                 break;
@@ -1888,7 +1716,7 @@ public class World implements MutableWorldSource {
                         }
                         if (!isMaterial) continue;
 
-                        if (aabb.intersects(block.getBlockBoundsFromState(this, _x, _y, _z).move(_x, _y, _z))){
+                        if (aabb.intersectsAABB(block.getBoundsFromState(this, tilePos).translate(tilePos.x, tilePos.y, tilePos.z, new AABBd()))) {
                             return true;
                         }
 
@@ -1900,28 +1728,24 @@ public class World implements MutableWorldSource {
         return false;
     }
 
-    public boolean isMaterialInBB(AABB aabb, Material material)
-    {
-        int minX_i = MathHelper.floor(aabb.minX);
-        int maxX_i = MathHelper.floor(aabb.maxX + 1.0D);
-        int minY_i = MathHelper.floor(aabb.minY);
-        int maxY_i = MathHelper.floor(aabb.maxY + 1.0D);
-        int minZ_i = MathHelper.floor(aabb.minZ);
-        int maxZ_i = MathHelper.floor(aabb.maxZ + 1.0D);
-        for(int _x = minX_i; _x < maxX_i; _x++)
-        {
-            for(int _y = minY_i; _y < maxY_i; _y++)
-            {
-                for(int _z = minZ_i; _z < maxZ_i; _z++)
-                {
-                    Block<?> block = Blocks.blocksList[getBlockId(_x, _y, _z)];
-                    if(block != null) {
+    public boolean isMaterialInBB(@NotNull AABBdc aabb, @NotNull Material material) {
+        int minX_i = MathHelper.floor(aabb.minX());
+        int maxX_i = MathHelper.floor(aabb.maxX() + 1.0D);
+        int minY_i = MathHelper.floor(aabb.minY());
+        int maxY_i = MathHelper.floor(aabb.maxY() + 1.0D);
+        int minZ_i = MathHelper.floor(aabb.minZ());
+        int maxZ_i = MathHelper.floor(aabb.maxZ() + 1.0D);
+        TilePos tilePos = new TilePos(0, 0, 0);
+        for (tilePos.x = minX_i; tilePos.x < maxX_i; tilePos.x++) {
+            for (tilePos.y = minY_i; tilePos.y < maxY_i; tilePos.y++) {
+                for (tilePos.z = minZ_i; tilePos.z < maxZ_i; tilePos.z++) {
+                    Block<?> block = getBlock(tilePos);
+                    if (block != null) {
                         if (block.getMaterial() != material) continue;
 
-                        if (aabb.intersects(block.getBlockBoundsFromState(this, _x, _y, _z).move(_x, _y, _z))){
+                        if (aabb.intersectsAABB(block.getBoundsFromState(this, tilePos).translate(tilePos.x, tilePos.y, tilePos.z, new AABBd()))) {
                             return true;
                         }
-
                     }
                 }
             }
@@ -1930,33 +1754,27 @@ public class World implements MutableWorldSource {
         return false;
     }
 
-    public boolean isAABBInMaterial(AABB aabb, Material material)
-    {
-        int i = MathHelper.floor(aabb.minX);
-        int j = MathHelper.floor(aabb.maxX + 1.0D);
-        int k = MathHelper.floor(aabb.minY);
-        int l = MathHelper.floor(aabb.maxY + 1.0D);
-        int i1 = MathHelper.floor(aabb.minZ);
-        int j1 = MathHelper.floor(aabb.maxZ + 1.0D);
-        for(int k1 = i; k1 < j; k1++)
-        {
-            for(int l1 = k; l1 < l; l1++)
-            {
-                for(int i2 = i1; i2 < j1; i2++)
-                {
-                    Block<?> block = Blocks.blocksList[getBlockId(k1, l1, i2)];
-                    if(block == null || block.getMaterial() != material)
-                    {
+    public boolean isAABBInMaterial(@NotNull AABBdc aabb, @NotNull Material material) {
+        int minX = MathHelper.floor(aabb.minX());
+        int maxX = MathHelper.floor(aabb.maxX() + 1.0D);
+        int minY = MathHelper.floor(aabb.minY());
+        int maxY = MathHelper.floor(aabb.maxY() + 1.0D);
+        int minZ = MathHelper.floor(aabb.minZ());
+        int maxZ = MathHelper.floor(aabb.maxZ() + 1.0D);
+        TilePos tilePos = new TilePos(0, 0, 0);
+        for (tilePos.x = minX; tilePos.x < maxX; tilePos.x++) {
+            for (tilePos.y = minY; tilePos.y < maxY; tilePos.y++) {
+                for (tilePos.z = minZ; tilePos.z < maxZ; tilePos.z++) {
+                    Block<?> block = getBlock(tilePos);
+                    if (block == null || block.getMaterial() != material) {
                         continue;
                     }
-                    int j2 = getBlockMetadata(k1, l1, i2);
-                    double d = l1 + 1;
-                    if(j2 < 8)
-                    {
-                        d = (double)(l1 + 1) - (double)j2 / 8D;
+                    int j2 = getBlockData(tilePos);
+                    double d = tilePos.y + 1;
+                    if (j2 < 8) {
+                        d = (double) (tilePos.y + 1) - (double) j2 / 8D;
                     }
-                    if(d >= aabb.minY)
-                    {
+                    if (d >= aabb.minY()) {
                         return true;
                     }
                 }
@@ -1968,15 +1786,13 @@ public class World implements MutableWorldSource {
         return false;
     }
 
-    public Explosion createExplosion(Entity entity, double x, double y, double z, float explosionSize)
-    {
+    public Explosion createExplosion(Entity entity, double x, double y, double z, float explosionSize) {
         return createExplosion(entity, x, y, z, explosionSize, false, false);
     }
 
-    public Explosion createExplosion(Entity entity, double x, double y, double z, float explosionSize, boolean flaming, boolean isCannonBall)
-    {
+    public Explosion createExplosion(Entity entity, double x, double y, double z, float explosionSize, boolean flaming, boolean isCannonBall) {
         Explosion explosion;
-        if(!isCannonBall)
+        if (!isCannonBall)
             explosion = new Explosion(this, entity, x, y, z, explosionSize);
         else
             explosion = new ExplosionCannonball(this, entity, x, y, z, explosionSize);
@@ -1986,24 +1802,20 @@ public class World implements MutableWorldSource {
         return explosion;
     }
 
-    public float getSeenPercent(Vec3 vec3, AABB aabb)
-    {
-        double d = 1.0D / ((aabb.maxX - aabb.minX) * 2D + 1.0D);
-        double d1 = 1.0D / ((aabb.maxY - aabb.minY) * 2D + 1.0D);
-        double d2 = 1.0D / ((aabb.maxZ - aabb.minZ) * 2D + 1.0D);
+    public float getSeenPercent(@NotNull Vector3dc eyePos, @NotNull AABBdc aabb) {
+        double d = 1.0D / ((aabb.maxX() - aabb.minX()) * 2D + 1.0D);
+        double d1 = 1.0D / ((aabb.maxY() - aabb.minY()) * 2D + 1.0D);
+        double d2 = 1.0D / ((aabb.maxZ() - aabb.minZ()) * 2D + 1.0D);
         int i = 0;
         int j = 0;
-        for(float f = 0.0F; f <= 1.0F; f = (float)((double)f + d))
-        {
-            for(float f1 = 0.0F; f1 <= 1.0F; f1 = (float)((double)f1 + d1))
-            {
-                for(float f2 = 0.0F; f2 <= 1.0F; f2 = (float)((double)f2 + d2))
-                {
-                    double d3 = aabb.minX + (aabb.maxX - aabb.minX) * (double)f;
-                    double d4 = aabb.minY + (aabb.maxY - aabb.minY) * (double)f1;
-                    double d5 = aabb.minZ + (aabb.maxZ - aabb.minZ) * (double)f2;
-                    if(checkBlockCollisionBetweenPoints(Vec3.fromPool(d3, d4, d5), vec3) == null)
-                    {
+        Vector3d entCheckPos = new Vector3d();
+        for (float f = 0.0F; f <= 1.0F; f = (float) ((double) f + d)) {
+            for (float f1 = 0.0F; f1 <= 1.0F; f1 = (float) ((double) f1 + d1)) {
+                for (float f2 = 0.0F; f2 <= 1.0F; f2 = (float) ((double) f2 + d2)) {
+                    double x = aabb.minX() + (aabb.maxX() - aabb.minX()) * (double) f;
+                    double y = aabb.minY() + (aabb.maxY() - aabb.minY()) * (double) f1;
+                    double z = aabb.minZ() + (aabb.maxZ() - aabb.minZ()) * (double) f2;
+                    if (checkBlockCollisionBetweenPoints(eyePos, entCheckPos.set(x, y, z)) == null) {
                         i++;
                     }
                     j++;
@@ -2013,11 +1825,11 @@ public class World implements MutableWorldSource {
 
         }
 
-        return (float)i / (float)j;
+        return (float) i / (float) j;
     }
 
     public void onBlockHit(final @NotNull Player player, final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final @NotNull TilePos offsetPos = tilePos.add(side.getDirection());
+        final @NotNull TilePos offsetPos = tilePos.add(side.getDirection(), new TilePos());
         final @Nullable Block<?> block = this.getBlock(offsetPos);
 
         if (block == Blocks.FIRE || block == Blocks.FIRE_COLD) {
@@ -2031,13 +1843,10 @@ public class World implements MutableWorldSource {
         this.onBlockHit(player, new TilePos(x, y, z), side);
     }
 
-    public @Nullable Entity getEntityByID(int id)
-    {
-        for(int i = 0; i < entities.size(); i++)
-        {
-            Entity entity = entities.get(i);
-            if(entity.id == id)
-            {
+    public @Nullable Entity getEntityByID(int id) {
+        for (int i = 0; i < this.entities.size(); i++) {
+            Entity entity = this.entities.get(i);
+            if (entity.id == id) {
                 return entity;
             }
         }
@@ -2045,33 +1854,31 @@ public class World implements MutableWorldSource {
         return null;
     }
 
-    public String getNumLoadedEntitiesString()
-    {
-        return "All: " + entities.size();
+    public String getNumLoadedEntitiesString() {
+        return "All: " + this.entities.size();
     }
 
-    public String getChunkProviderInfoString()
-    {
-        return chunkProvider.getInfoString();
+    public String getChunkProviderInfoString() {
+        return this.chunkProvider.getInfoString();
     }
 
     @Override
-    public @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos) {
+    public @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos) {
         final @NotNull Chunk chunk = this.getChunk(tilePos);
-        return chunk.getTileEntity(tilePos.toChunkTilePos());
+        return chunk.getTileEntity(new ChunkTilePos(tilePos));
     }
 
     @Override
-    public void setTileEntity(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
+    public void setTileEntity(final @NotNull TilePosc tilePos, final @NotNull TileEntity tileEntity) {
         if (!tileEntity.isInvalid()) {
-            if (this.getChunk(tilePos).setTileEntity(tilePos.toChunkTilePos(), tileEntity) && !this.tileEntityList.contains(tileEntity)) {
+            if (this.getChunk(tilePos).setTileEntity(new ChunkTilePos(tilePos), tileEntity) && !this.tileEntityList.contains(tileEntity)) {
                 this.tileEntityList.add(tileEntity);
             }
         }
     }
 
     @Override
-    public void removeTileEntity(final @NotNull TilePos tilePos) {
+    public void removeTileEntity(final @NotNull TilePosc tilePos) {
         final @Nullable TileEntity tileEntity = this.getTileEntity(tilePos);
 
         if (tileEntity != null && this.updatingTileEntities) {
@@ -2086,7 +1893,7 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public boolean isBlockOpaqueCube(final @NotNull TilePos tilePos) {
+    public boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         return block != null && block.isSolidRender();
     }
@@ -2116,13 +1923,13 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public boolean isBlockNormalCube(final @NotNull TilePos tilePos) {
+    public boolean isBlockNormalCube(final @NotNull TilePosc tilePos) {
         // Determines if you suffocate in a block, among other things.
         final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
+        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
     }
 
-    public boolean canPlaceInsideBlock(final @NotNull TilePos tilePos) {
+    public boolean canPlaceInsideBlock(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         return block == null || block.hasTag(BlockTags.PLACE_OVERWRITES);
     }
@@ -2132,8 +1939,7 @@ public class World implements MutableWorldSource {
         return this.canPlaceInsideBlock(new TilePos(x, y, z));
     }
 
-    public void onUnload()
-    {
+    public void onUnload() {
         // Unloads all entities
         try {
             updateEntities();
@@ -2141,8 +1947,8 @@ public class World implements MutableWorldSource {
             LOGGER.error("Unhandled exception while unloading all entities!", t);
             throw t;
         } finally {
-            entities.clear();
-            entitiesToRemove.clear();
+            this.entities.clear();
+            this.entitiesToRemove.clear();
         }
     }
 
@@ -2150,13 +1956,11 @@ public class World implements MutableWorldSource {
         this.chunkProvider.close();
     }
 
-    public void saveWorldIndirectly(ProgressListener iprogressupdate)
-    {
+    public void saveWorldIndirectly(ProgressListener iprogressupdate) {
         saveWorld(true, iprogressupdate, true);
     }
 
-    public boolean updatingLighting()
-    {
+    public boolean updatingLighting() {
         return this.lightingEngine.updatingLighting();
     }
 
@@ -2177,7 +1981,7 @@ public class World implements MutableWorldSource {
     }
 
     public LightingEngine getLightingEngine() {
-        return lightingEngine;
+        return this.lightingEngine;
     }
 
     @Deprecated
